Index: palm/trunk/SOURCE/virtual_measurement_mod.f90
===================================================================
--- palm/trunk/SOURCE/virtual_measurement_mod.f90	(revision 4497)
+++ palm/trunk/SOURCE/virtual_measurement_mod.f90	(revision 4498)
@@ -1210,9 +1127,6 @@
                       DO  j = js-off, js+off
                          DO  k = kl, ku
-                            meas_flag(k,j,i) = MERGE(                           &
-                                          IBSET( meas_flag(k,j,i), 0 ),         &
-                                          0,                                    &
-                                          BTEST( wall_flags_total_0(k,j,i), 0 ) &
-                                                    )
+                            meas_flag(k,j,i) = MERGE( IBSET( meas_flag(k,j,i), 0 ), 0,             &
+                                               BTEST( wall_flags_total_0(k,j,i), 0 ) )
                          ENDDO
                       ENDDO
@@ -1223,8 +1137,7 @@
           ENDDO
 !
-!--       Based on the flag array count the number of sampling coordinates.
-!--       Please note, sampling coordinates in atmosphere and soil may be
-!--       different, as within the soil all levels will be measured.
-!--       Hence, count individually. Start with atmoshere.
+!--       Based on the flag array, count the number of sampling coordinates. Please note, sampling
+!--       coordinates in atmosphere and soil may be different, as within the soil all levels will be
+!--       measured. Hence, count individually. Start with atmoshere.
           ns = 0
           DO  i = nxl-off, nxr+off
@@ -1237,6 +1150,6 @@
 
 !
-!--       Store number of observation points on subdomain and allocate index
-!--       arrays as well as array containing height information.
+!--       Store number of observation points on subdomain and allocate index arrays as well as array
+!--       containing height information.
           vmea(l)%ns = ns
 
@@ -1246,6 +1159,6 @@
           ALLOCATE( vmea(l)%zar(1:vmea(l)%ns) )
 !
-!--       Based on the flag array store the grid indices which correspond to
-!--       the observation coordinates.
+!--       Based on the flag array store the grid indices which correspond to the observation
+!--       coordinates.
           ns = 0
           DO  i = nxl-off, nxr+off
@@ -1263,21 +1176,16 @@
           ENDDO
 !
-!--       Same for the soil. Based on the flag array, count the number of
-!--       sampling coordinates in soil. Sample at all soil levels in this case.
-!--       Please note, soil variables can only be sampled on subdomains, not
-!--       on ghost layers.
+!--       Same for the soil. Based on the flag array, count the number of sampling coordinates in
+!--       soil. Sample at all soil levels in this case. Please note, soil variables can only be
+!--       sampled on subdomains, not on ghost layers.
           IF ( vmea(l)%soil_sampling )  THEN
              DO  i = nxl, nxr
                 DO  j = nys, nyn
                    IF ( ANY( BTEST( meas_flag(:,j,i), 0 ) ) )  THEN
-                      IF ( surf_lsm_h%start_index(j,i) <=                      &
-                           surf_lsm_h%end_index(j,i) )  THEN
-                         vmea(l)%ns_soil = vmea(l)%ns_soil +                   &
-                                                      nzt_soil - nzb_soil + 1
+                      IF ( surf_lsm_h%start_index(j,i) <= surf_lsm_h%end_index(j,i) )  THEN
+                         vmea(l)%ns_soil = vmea(l)%ns_soil + nzt_soil - nzb_soil + 1
                       ENDIF
-                      IF ( surf_usm_h%start_index(j,i) <=                      &
-                           surf_usm_h%end_index(j,i) )  THEN
-                         vmea(l)%ns_soil = vmea(l)%ns_soil +                   &
-                                                      nzt_wall - nzb_wall + 1
+                      IF ( surf_usm_h%start_index(j,i) <= surf_usm_h%end_index(j,i) )  THEN
+                         vmea(l)%ns_soil = vmea(l)%ns_soil + nzt_wall - nzb_wall + 1
                       ENDIF
                    ENDIF
@@ -1286,6 +1194,5 @@
           ENDIF
 !
-!--       Allocate index arrays as well as array containing height information
-!--       for soil.
+!--       Allocate index arrays as well as array containing height information for soil.
           IF ( vmea(l)%soil_sampling )  THEN
              ALLOCATE( vmea(l)%i_soil(1:vmea(l)%ns_soil) )
@@ -1301,6 +1208,5 @@
                 DO  j = nys, nyn
                    IF ( ANY( BTEST( meas_flag(:,j,i), 0 ) ) )  THEN
-                      IF ( surf_lsm_h%start_index(j,i) <=                      &
-                           surf_lsm_h%end_index(j,i) )  THEN
+                      IF ( surf_lsm_h%start_index(j,i) <= surf_lsm_h%end_index(j,i) )  THEN
                          m = surf_lsm_h%start_index(j,i)
                          DO  k = nzb_soil, nzt_soil
@@ -1313,6 +1219,5 @@
                       ENDIF
 
-                      IF ( surf_usm_h%start_index(j,i) <=                      &
-                           surf_usm_h%end_index(j,i) )  THEN
+                      IF ( surf_usm_h%start_index(j,i) <= surf_usm_h%end_index(j,i) )  THEN
                          m = surf_usm_h%start_index(j,i)
                          DO  k = nzb_wall, nzt_wall
@@ -1332,13 +1237,11 @@
           ALLOCATE( vmea(l)%measured_vars(1:vmea(l)%ns,1:vmea(l)%nmeas) )
 
-          IF ( vmea(l)%soil_sampling )                                         &
-             ALLOCATE( vmea(l)%measured_vars_soil(1:vmea(l)%ns_soil,           &
-                                                  1:vmea(l)%nmeas) )
+          IF ( vmea(l)%soil_sampling )                                                             &
+             ALLOCATE( vmea(l)%measured_vars_soil(1:vmea(l)%ns_soil, 1:vmea(l)%nmeas) )
 !
 !--       Initialize with _FillValues
           vmea(l)%measured_vars(1:vmea(l)%ns,1:vmea(l)%nmeas) = vmea(l)%fillout
-          IF ( vmea(l)%soil_sampling )                                         &
-             vmea(l)%measured_vars_soil(1:vmea(l)%ns_soil,1:vmea(l)%nmeas) =   &
-                                                                vmea(l)%fillout
+          IF ( vmea(l)%soil_sampling )                                                             &
+             vmea(l)%measured_vars_soil(1:vmea(l)%ns_soil,1:vmea(l)%nmeas) = vmea(l)%fillout
 !
 !--       Deallocate temporary coordinate arrays
@@ -1366,6 +1269,6 @@
     ns_all = 0
 #if defined( __parallel )
-    CALL MPI_ALLREDUCE( vmea(:)%ns, ns_all(:), vmea_general%nvm, MPI_INTEGER,  &
-                        MPI_SUM, comm2d, ierr )
+    CALL MPI_ALLREDUCE( vmea(:)%ns, ns_all(:), vmea_general%nvm,                                   &
+                        MPI_INTEGER, MPI_SUM, comm2d, ierr )
 #else
     ns_all(:) = vmea(:)%ns
@@ -1376,5 +1279,5 @@
     ns_all = 0
 #if defined( __parallel )
-    CALL MPI_ALLREDUCE( vmea(:)%ns_soil, ns_all(:), vmea_general%nvm,          &
+    CALL MPI_ALLREDUCE( vmea(:)%ns_soil, ns_all(:), vmea_general%nvm,                              &
                         MPI_INTEGER, MPI_SUM, comm2d, ierr )
 #else
@@ -1385,6 +1288,6 @@
     DEALLOCATE( ns_all )
 !
-!-- In case of parallel NetCDF the start coordinate for each mpi rank needs to
-!-- be defined, so that each processor knows where to write the data.
+!-- In case of parallel NetCDF the start coordinate for each mpi rank needs to be defined, so that
+!-- each processor knows where to write the data.
 #if defined( __netcdf4_parallel )
     ALLOCATE( ns_atmos(0:numprocs-1,1:vmea_general%nvm) )
@@ -1399,7 +1302,7 @@
 
 #if defined( __parallel )
-    CALL MPI_ALLREDUCE( MPI_IN_PLACE, ns_atmos, numprocs * vmea_general%nvm,   &
+    CALL MPI_ALLREDUCE( MPI_IN_PLACE, ns_atmos, numprocs * vmea_general%nvm,                       &
                         MPI_INTEGER, MPI_SUM, comm2d, ierr )
-    CALL MPI_ALLREDUCE( MPI_IN_PLACE, ns_soil, numprocs * vmea_general%nvm,    &
+    CALL MPI_ALLREDUCE( MPI_IN_PLACE, ns_soil, numprocs * vmea_general%nvm,                        &
                         MPI_INTEGER, MPI_SUM, comm2d, ierr )
 #else
@@ -1409,8 +1312,7 @@
 
 !
-!-- Determine the start coordinate in NetCDF file for the local arrays.
-!-- Note, start coordinates are initialized with zero for sake of simplicity
-!-- in summation. However, in NetCDF the start coordinates must be >= 1,
-!-- so that a one needs to be added at the end.
+!-- Determine the start coordinate in NetCDF file for the local arrays. Note, start coordinates are
+!-- initialized with zero for sake of simplicity in summation. However, in NetCDF the start
+!-- coordinates must be >= 1, so that a one needs to be added at the end.
     DO  l = 1, vmea_general%nvm
        DO  n  = 0, myid - 1
@@ -1435,29 +1337,29 @@
 #endif
 
-  END SUBROUTINE vm_init
-
-
-!------------------------------------------------------------------------------!
+ END SUBROUTINE vm_init
+
+
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Initialize output using data-output module
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
  SUBROUTINE vm_init_output
 
     CHARACTER(LEN=100) ::  variable_name  !< name of output variable
 
-    INTEGER(iwp) ::  l              !< loop index
-    INTEGER(iwp) ::  n              !< loop index
-    INTEGER      ::  return_value   !< returned status value of called function
+    INTEGER(iwp) ::  l             !< loop index
+    INTEGER(iwp) ::  n             !< loop index
+    INTEGER      ::  return_value  !< returned status value of called function
 
     INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  ndim !< dummy to write dimension
 
-    REAL(wp) ::  dum_lat !< transformed geographical coordinate (latitude)
-    REAL(wp) ::  dum_lon !< transformed geographical coordinate (longitude)
+    REAL(wp) ::  dum_lat  !< transformed geographical coordinate (latitude)
+    REAL(wp) ::  dum_lon  !< transformed geographical coordinate (longitude)
 
 !
 !-- Determine the number of output timesteps.
-    ntimesteps = CEILING(                                                      &
-                  ( end_time - MAX( vm_time_start, time_since_reference_point )&
+    ntimesteps = CEILING(                                                                          &
+                  ( end_time - MAX( vm_time_start, time_since_reference_point )                    &
                   ) / dt_virtual_measurement )
 !
@@ -1472,7 +1374,6 @@
 !
 !--    Define output file.
-       WRITE( vmea(l)%nc_filename, '(A,I4.4)' ) 'VM_OUTPUT' //                 &
-                                                TRIM( coupling_char ) // '/' //&
-                                                'site', l
+       WRITE( vmea(l)%nc_filename, '(A,I4.4)' ) 'VM_OUTPUT' // TRIM( coupling_char ) // '/' //     &
+              'site', l
 
        return_value = dom_def_file( vmea(l)%nc_filename, 'netcdf4-parallel' )
@@ -1480,98 +1381,95 @@
 !--    Define global attributes.
 !--    Before, transform UTM into geographical coordinates.
-       CALL convert_utm_to_geographic( crs_list,                               &
-                                       vmea(l)%origin_x_obs,                   &
-                                       vmea(l)%origin_y_obs,                   &
-                                       dum_lon,                                &
-                                       dum_lat )
-
-       return_value = dom_def_att( vmea(l)%nc_filename,                        &
-                                   attribute_name = 'site',                    &
+       CALL convert_utm_to_geographic( crs_list, vmea(l)%origin_x_obs, vmea(l)%origin_y_obs,       &
+                                       dum_lon, dum_lat )
+
+       return_value = dom_def_att( vmea(l)%nc_filename,                                            &
+                                   attribute_name = 'site',                                        &
                                    value = TRIM( vmea(l)%site ) )
-       return_value = dom_def_att( vmea(l)%nc_filename,                        &
-                                   attribute_name = 'title',                   &
+       return_value = dom_def_att( vmea(l)%nc_filename,                                            &
+                                   attribute_name = 'title',                                       &
                                    value = 'Virtual measurement output')
-       return_value = dom_def_att( vmea(l)%nc_filename,                        &
-                                   attribute_name = 'source',                  &
+       return_value = dom_def_att( vmea(l)%nc_filename,                                            &
+                                   attribute_name = 'source',                                      &
                                    value = 'PALM-4U')
-       return_value = dom_def_att( vmea(l)%nc_filename,                        &
-                                   attribute_name = 'institution',             &
+       return_value = dom_def_att( vmea(l)%nc_filename,                                            &
+                                   attribute_name = 'institution',                                 &
                                    value = input_file_atts%institution )
-       return_value = dom_def_att( vmea(l)%nc_filename,                        &
-                                   attribute_name = 'acronym',                 &
+       return_value = dom_def_att( vmea(l)%nc_filename,                                            &
+                                   attribute_name = 'acronym',                                     &
                                    value = input_file_atts%acronym )
-       return_value = dom_def_att( vmea(l)%nc_filename,                        &
-                                   attribute_name = 'author',                  &
+       return_value = dom_def_att( vmea(l)%nc_filename,                                            &
+                                   attribute_name = 'author',                                      &
                                    value = input_file_atts%author )
-       return_value = dom_def_att( vmea(l)%nc_filename,                        &
-                                   attribute_name = 'contact_person',          &
+       return_value = dom_def_att( vmea(l)%nc_filename,                                            &
+                                   attribute_name = 'contact_person',                              &
                                    value = input_file_atts%contact_person )
-       return_value = dom_def_att( vmea(l)%nc_filename,                        &
-                                   attribute_name = 'iop',                     &
+       return_value = dom_def_att( vmea(l)%nc_filename,                                            &
+                                   attribute_name = 'iop',                                         &
                                    value = input_file_atts%campaign )
-       return_value = dom_def_att( vmea(l)%nc_filename,                        &
-                                   attribute_name = 'campaign',                &
+       return_value = dom_def_att( vmea(l)%nc_filename,                                            &
+                                   attribute_name = 'campaign',                                    &
                                    value = 'PALM-4U' )
-       return_value = dom_def_att( vmea(l)%nc_filename,                        &
-                                   attribute_name = 'origin_time ',            &
+       return_value = dom_def_att( vmea(l)%nc_filename,                                            &
+                                   attribute_name = 'origin_time ',                                &
                                    value = origin_date_time)
-       return_value = dom_def_att( vmea(l)%nc_filename,                        &
-                                   attribute_name = 'location',                &
+       return_value = dom_def_att( vmea(l)%nc_filename,                                            &
+                                   attribute_name = 'location',                                    &
                                    value = input_file_atts%location )
-       return_value = dom_def_att( vmea(l)%nc_filename,                        &
-                                   attribute_name = 'origin_x',                &
+       return_value = dom_def_att( vmea(l)%nc_filename,                                            &
+                                   attribute_name = 'origin_x',                                    &
                                    value = vmea(l)%origin_x_obs )
-       return_value = dom_def_att( vmea(l)%nc_filename,                        &
-                                   attribute_name = 'origin_y',                &
+       return_value = dom_def_att( vmea(l)%nc_filename,                                            &
+                                   attribute_name = 'origin_y',                                    &
                                    value = vmea(l)%origin_y_obs )
-       return_value = dom_def_att( vmea(l)%nc_filename,                        &
-                                   attribute_name = 'origin_lon',              &
+       return_value = dom_def_att( vmea(l)%nc_filename,                                            &
+                                   attribute_name = 'origin_lon',                                  &
                                    value = dum_lon )
-       return_value = dom_def_att( vmea(l)%nc_filename,                        &
-                                   attribute_name = 'origin_lat',              &
+       return_value = dom_def_att( vmea(l)%nc_filename,                                            &
+                                   attribute_name = 'origin_lat',                                  &
                                    value = dum_lat )
-       return_value = dom_def_att( vmea(l)%nc_filename,                        &
-                                   attribute_name = 'origin_z',                &
+       return_value = dom_def_att( vmea(l)%nc_filename,                                            &
+                                   attribute_name = 'origin_z',                                    &
                                    value = 0.0 )
-       return_value = dom_def_att( vmea(l)%nc_filename,                        &
-                                   attribute_name = 'rotation_angle',          &
+       return_value = dom_def_att( vmea(l)%nc_filename,                                            &
+                                   attribute_name = 'rotation_angle',                              &
                                    value = input_file_atts%rotation_angle )
-       return_value = dom_def_att( vmea(l)%nc_filename,                        &
-                                   attribute_name = 'featureType',             &
+       return_value = dom_def_att( vmea(l)%nc_filename,                                            &
+                                   attribute_name = 'featureType',                                 &
                                    value = TRIM( vmea(l)%feature_type_out ) )
-       return_value = dom_def_att( vmea(l)%nc_filename,                        &
-                                   attribute_name = 'data_content',            &
+       return_value = dom_def_att( vmea(l)%nc_filename,                                            &
+                                   attribute_name = 'data_content',                                &
                                    value = TRIM( vmea(l)%data_content ) )
-       return_value = dom_def_att( vmea(l)%nc_filename,                        &
-                                   attribute_name = 'creation_time',           &
+       return_value = dom_def_att( vmea(l)%nc_filename,                                            &
+                                   attribute_name = 'creation_time',                               &
                                    value = input_file_atts%creation_time )
-       return_value = dom_def_att( vmea(l)%nc_filename,                        &
-                                   attribute_name = 'version',                 &
+       return_value = dom_def_att( vmea(l)%nc_filename,                                            &
+                                   attribute_name = 'version',                                     &
                                    value = 1 ) !input_file_atts%version )
-       return_value = dom_def_att( vmea(l)%nc_filename,                        &
-                                   attribute_name = 'creation_time',           &
+       return_value = dom_def_att( vmea(l)%nc_filename,                                            &
+                                   attribute_name = 'creation_time',                               &
                                    value = TRIM( vmea(l)%site ) )
-       return_value = dom_def_att( vmea(l)%nc_filename,                        &
-                                   attribute_name = 'Conventions',             &
+       return_value = dom_def_att( vmea(l)%nc_filename,                                            &
+                                   attribute_name = 'Conventions',                                 &
                                    value = input_file_atts%conventions )
-       return_value = dom_def_att( vmea(l)%nc_filename,                        &
-                                   attribute_name = 'dependencies',            &
+       return_value = dom_def_att( vmea(l)%nc_filename,                                            &
+                                   attribute_name = 'dependencies',                                &
                                    value = input_file_atts%dependencies )
-       return_value = dom_def_att( vmea(l)%nc_filename,                        &
-                                   attribute_name = 'history',                 &
+       return_value = dom_def_att( vmea(l)%nc_filename,                                            &
+                                   attribute_name = 'history',                                     &
                                    value = input_file_atts%history )
-       return_value = dom_def_att( vmea(l)%nc_filename,                        &
-                                   attribute_name = 'references',              &
+       return_value = dom_def_att( vmea(l)%nc_filename,                                            &
+                                   attribute_name = 'references',                                  &
                                    value = input_file_atts%references )
-       return_value = dom_def_att( vmea(l)%nc_filename,                        &
-                                   attribute_name = 'comment',                 &
+       return_value = dom_def_att( vmea(l)%nc_filename,                                            &
+                                   attribute_name = 'comment',                                     &
                                    value = input_file_atts%comment )
-       return_value = dom_def_att( vmea(l)%nc_filename,                        &
-                                   attribute_name = 'keywords',                &
+       return_value = dom_def_att( vmea(l)%nc_filename,                                            &
+                                   attribute_name = 'keywords',                                    &
                                    value = input_file_atts%keywords )
-       return_value = dom_def_att( vmea(l)%nc_filename,                        &
-                                   attribute_name = 'licence',                 &
-                                   value = '[UC]2 Open Licence; see [UC]2 ' // &
-                                           'data policy available at ' //      &
+       return_value = dom_def_att( vmea(l)%nc_filename,                                            &
+                                   attribute_name = 'licence',                                     &
+                                   value = '[UC]2 Open Licence; see [UC]2 ' //                     &
+                                           'data policy available at ' //                          &
                                            'www.uc2-program.org/uc2_data_policy.pdf' )
 !
@@ -1582,8 +1480,6 @@
           ndim(n) = n
        ENDDO
-       return_value = dom_def_dim( vmea(l)%nc_filename,                        &
-                                   dimension_name = 'station',                 &
-                                   output_type = 'int32',                      &
-                                   bounds = (/1_iwp, vmea(l)%ns_tot/),         &
+       return_value = dom_def_dim( vmea(l)%nc_filename, dimension_name = 'station',                &
+                                   output_type = 'int32', bounds = (/1_iwp, vmea(l)%ns_tot/),      &
                                    values_int32 = ndim )
        DEALLOCATE( ndim )
@@ -1595,8 +1491,6 @@
        ENDDO
 
-       return_value = dom_def_dim( vmea(l)%nc_filename,                        &
-                                   dimension_name = 'ntime',                   &
-                                   output_type = 'int32',                      &
-                                   bounds = (/1_iwp, ntimesteps/),             &
+       return_value = dom_def_dim( vmea(l)%nc_filename, dimension_name = 'ntime',                  &
+                                   output_type = 'int32', bounds = (/1_iwp, ntimesteps/),          &
                                    values_int32 = ndim )
        DEALLOCATE( ndim )
@@ -1608,8 +1502,6 @@
        ENDDO
 
-       return_value = dom_def_dim( vmea(l)%nc_filename,                        &
-                                   dimension_name = 'nv',                      &
-                                   output_type = 'int32',                      &
-                                   bounds = (/1_iwp, 2_iwp/),                  &
+       return_value = dom_def_dim( vmea(l)%nc_filename, dimension_name = 'nv',                     &
+                                   output_type = 'int32', bounds = (/1_iwp, 2_iwp/),               &
                                    values_int32 = ndim )
        DEALLOCATE( ndim )
@@ -1621,9 +1513,7 @@
        ENDDO
 
-       return_value = dom_def_dim( vmea(l)%nc_filename,                        &
-                                   dimension_name = 'max_name_len',            &
-                                   output_type = 'int32',                      &
-                                   bounds = (/1_iwp, maximum_name_length /),   &
-                                   values_int32 = ndim )
+       return_value = dom_def_dim( vmea(l)%nc_filename, dimension_name = 'max_name_len',           &
+                                   output_type = 'int32',                                          &
+                                   bounds = (/1_iwp, maximum_name_length /), values_int32 = ndim )
        DEALLOCATE( ndim )
 !
